#!/bin/bash

declare -a earray
declare -a day_array
declare -a time_array
declare -a size_array

IFS=$'\n'
bucket="$1"
user="$2"
domain="$3"
work="/data/ses/$domain/$user/workdir"
dest_register="/data/ses/$domain/$user/register.csv"
dest_block="/data/ses/$domain/$user/register_block.csv"
adir="/data/ses/$domain/$user/archivedir"
ffile="/data/ses/$domain/$user/forward.dat"
cfile="/data/ses/$domain/$user/content.dat"

unset IFS


for sets in `cat /data/ses/$domain/$user/sets.dat`
do

content=""
content=`grep $sets $cfile`
if [ "$content" != "" ] ;
then
content="y"
fi

cd $work 

aws s3 sync s3://$bucket/$sets/ $work

if [ -f "$work/AMAZON_SES_SETUP_NOTIFICATION" ] ; 
then
aws s3 rm s3://$bucket/$sets/AMAZON_SES_SETUP_NOTIFICATION
rm -f $work/AMAZON_SES_SETUP_NOTIFICATION
fi

lf=""
lf=`ls *`
if [ "$lf" != "" ] ;
then
 fcount=0
  for file in `ls *` 
  do
#    let fcount=$fcount+1
   fcount=$(expr $fcount + 1)
   earray[$fcount]="$file"
   size=""
   time=""
   day=""
   sta=""
   sta=`stat $file | grep "Access:"|tail -1`
   day=`echo $sta | grep "Access:"|tail -1|awk '{print $2}'|awk -F- '{print $1,$2,$3}'`
   time=`echo $sta | grep "Access:"|tail -1|awk -F. '{print $1}'|awk '{print $NF}'`
   day_array[$fcount]="$day"
   time_array[$fcount]="$time"
   size=`stat $file | grep "Size:"|head -1|awk '{print $2}'`
   size_array[$fcount]="$size"
   chmod 777 $file
   # chgrp ec2-user $file
   done
fi


archive_email()
{
day=""; time=""; size="";from="";to="";subject=""
day=${day_array[$email]}
time=${time_array[$email]}
size=${size_array[$email]}
from=`grep "From: " $work/$efile|awk '{print $NF}'|sed 's/
//g'`
to=`grep "To:[ ]" $work/$efile|sed 's/,/-/g'|awk -FTo: '{print $NF}'|sed 's/
//g'`
subject=`grep "Subject: " $work/$efile|sed 's/,/-/g'|awk -F: '{print $NF}'|awk '{$1=$1}1'`
echo $day , $time , $size , $efile, $from, $to, $subject >> $dest_register

IFS=$'\n'

aws s3 cp $adir/$efile.eml s3://$bucket/.archive/$efile.eml
}

archive_header()
{
cat $work/$efile | sed '0,/Subject: /{s//Subject: [archive] /}' | sed 's/
//g' > $adir/$efile.tmp
mv $adir/$efile.tmp $adir/$efile.eml
}

dmarc_function()
{
	m=""
        m=`grep "Subject: " $work/$efile | grep -i "Report Domain"`
	n=""
	n=`grep "dmarcreport" $work/$efile`
	if [ "$m" != "" ] || [ "$n" != "" ] ;
        then
        aws s3 cp $work/$efile s3://$bucket/.other/$efile.eml
        # dmarc_ret=1
        dmarc_ret=$(expr 1)
	fi
echo "$dmarc_ret"
	# return $($dmarc_ret)
        return "$dmarc_ret"        
}

fail_function()
{
	flag=""
	 o=""
	 o=`head -15 $work/$efile|grep -i "Received-SPF: pass"| awk '{print $1,$2}'`
      if [ "$o" = "" ] ;
      then
#         block_ret=1
       block_ret=$(expr 1)

      fi
        o=""
        o=`grep "X-SES-Spam-Verdict:" $work/$efile`
        p=""
        p=`grep "X-SES-Virus-Verdict:" $work/$efile`

        if [ "$o" != "" ] ;
        then
        k=""
        k=`echo $o|grep PASS`
         if [ "$k" = "" ] ;
          then
          block_ret=$(expr 2)
	  echo BLOCK RET 2
	  echo o: $o
          # block_ret=1
         fi
        fi

        if [ "$p" != "" ] ;
        then
        k=""
        k=`echo $p|grep PASS`
         if [ "$k" = "" ] ;
          then
          # block_ret=1
          block_ret=$(expr 3)
         fi
        fi

	d=""
        d=`grep "dmarc=fail" $work/$efile`
        if [ "$d" != "" ] ;
        then
        block_ret=$(expr 4)
        fi


# return "$block_ret"
# return ${$block_ret)
echo "$block_ret"
return "$block_ret"
}

block_email()
{
day=""; time=""; size="";from="";to="";subject=""
day=${day_array[$email]}
time=${time_array[$email]}
size=${size_array[$email]}
from=`grep "From: " $work/$efile|awk '{print $NF}'|sed 's/
//g'`
to=`grep "To:[ ]" $work/$efile|sed 's/,/-/g'|awk -FTo: '{print $NF}'|sed 's/
//g'`
subject=`grep "Subject: " $work/$efile|sed 's/,/-/g'|awk -F: '{print $NF}'|sed 's/
//g'`
echo $day , $time , $size , $efile, $from, $to, $subject >> $dest_block
aws s3 cp $work/$efile s3://$bucket/.other/$efile.eml
# echo "A BLOCKED e-mail attachment has arrived from Amazon SES for domain $domain" | EMAIL="mail $domain <admin@$domain>" /usr/bin/mutt -s "A BLOCKED e-mail from $domain" $forward -a $out/$efile.eml
}

reset_function()
{
# dmarc_ret=0
dmarc_ret=$(expr 0)
# block_ret=0
block_ret=$(expr 0)
}



# START PROGRAM

# dmarc_ret=0
dmarc_ret=$(expr 0)
block_ret=$(expr 0)

# FOR LOOP
if [ "$lf" != "" ] ;
then
email=0
for efile in ${earray[*]}
do
# let email=$email+1
email=$(expr $email + 1)
proc=""

dmarc_function
dmarc_ret=$?
fail_function
block_ret=$?

echo FAIL CODE block_ret: $block_ret

proc=""
if [ "$dmarc_ret" = "0" ] ;
then
:
else
proc="dmarc"
fi

if [ "$block_ret" = "1" ] || [ "$block_ret" = "2" ] || [ "$block_ret" = "3" ] || [ "$block_ret" = "4" ] ;
then
proc="block"
block_email
else
:
fi

archive_header

if [ "$proc" = "" ] ;
then
archive_email
proc="email"
fi

if [ "$work" != "" ] ;
 then
   if [ "$efile" != "" ] ;
   then
     if [ -f $work/$efile ] ;
     then
     rm -f $work/$efile
     aws s3 rm s3://$bucket/$sets/$efile
     fi

     if [ -f $adir/$efile.eml ] ;
     then
     rm -f $adir/$efile.eml ;
     fi

   fi
 fi

reset_function

done
# lf not null
fi
# end sets
done

# systemctl stop postfix - if this is required as a precaution

exit






